class Jobs
{
    $ResponseObject
    [String]$ResponseJson
    [Int]$ProjectId
    [Int]$BatchId
    [Int]$JobType
    [Int]$ProductType
    [string]$StartJobsList
    [string]$StopJobsList


    StartJobs(){
        
        $PType=$this.ProductType
        $JType=$this.JobType
        

        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Jobs/StartJobs/$PType/$JType"
            Headers = GetHeader
            ContentType = "application/json"
            Body = $this.StartJobsList
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }
 

    StopJobs(){
        
    $PType=$this.ProductType
    
    $Parameters = @{
        Method = "Post"
        Uri = "$global:HOSTURL/ap1/Jobs/StopJobs/$PType"
        Headers = GetHeader
        ContentType = "application/json"
        Body = $this.StopJobsList
    }
    
    $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
    $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }
   # /ap1/Jobs/batch/{batchId}/{jobTypeId}/{productType}
   StartBatchJobs(){
        
    $PType=$this.ProductType
    $JType=$this.JobType
    $bID=$this.BatchId
    
    $Parameters = @{
        Method = "Post"
        Uri = "$global:HOSTURL/ap1/Jobs/batch/$bID/$JType/$PType"
        Headers = GetHeader
        ContentType = "application/json"
        
    }
    
    $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
    $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
}
StopBatchJobs(){
        
    $PType=$this.ProductType
    $bID=$this.BatchId
    
    $Parameters = @{
        Method = "Post"
        Uri = "$global:HOSTURL/ap1/Jobs/batch/$bID/$PType"
        Headers = GetHeader
        ContentType = "application/json"
        
    }
    
    $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
    $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
}


}