class MailUser
{
    $ResponseObject
    [String]$ResponseJson

    [Int]$Id
    [String]$FirstName
    [String]$LastName
    [Int]$SourcePoolId
    [Int]$TargetPoolId
    [String]$SourceEmail
    [String]$TargetEmail
    [Int]$SourceRecipientType
    [Int]$TargetRecipientType
    [int]$BatchID
    [string]$BulkDeleteList

#     "id": 0,
#   "firstName": "string",
#   "lastName": "string",
#   "sourcePoolId": 0,
#   "targetPoolId": 0,
#   "sourceEmail": "string",
#   "targetEmail": "string",
#   "size": 0,
#   "sourceRecipientType": 0,
#   "targetRecipientType": 0,
#   "sku": 0,
#   "isLocked": true,
#   "timeStamp": "2021-12-01T15:43:57.071Z"

    GetUserList(){
        $BodyJson = @{
            page = 1
            pageSize = 500
        }

        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Mail/Displayable"
            Headers = GetHeader 
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }

        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100 
    }

    CreateNew(){
    
        $BodyJson = @{
            firstName = $this.FirstName
            lastName = $this.LastName
            sourcePoolId = $this.SourcePoolId
            targetPoolId = $this.TargetPoolId
            sourceEmail = $this.SourceEmail
            targetEmail = $this.TargetEmail
            targetRecipientType = $this.TargetRecipientType
            sourceRecipientType = $this.SourceRecipientType
        }
    
        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Mail"
            Headers = GetHeader
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }

    Update(){
        
        $objectId = $this.Id
        $BodyJson = @{
            firstName = $this.FirstName
            lastName = $this.LastName
            sourcePoolId = $this.SourcePoolId
            targetPoolId = $this.TargetPoolId
            sourceEmail = $this.SourceEmail
            targetEmail = $this.TargetEmail
            targetRecipientType = $this.TargetRecipientType
            sourceRecipientType = $this.SourceRecipientType
        }
    
        $Parameters = @{
            Method = "Put"
            Uri = "$global:HOSTURL/ap1/Mail/$objectId"
            Headers = GetHeader
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }

    BulkDelete(){
      
        $Parameters = @{
            Method = "Put"
            Uri = "$global:HOSTURL/ap1/Mail/BulkDelete"
            Headers = GetHeader
            ContentType = "application/json"
            Body = $this.BulkDeleteList   
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100          
    }
    SearchUser(){
   
        $BodyJson=@{ sourceEmail=$this.SourceEmail}

        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Mail/MailUserSearch"
            Headers = GetHeader 
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
      
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100  
    }

    GetUserLogs(){
   
        $objectId = $this.Id
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Mail/logs/$objectId"
            Headers =GetHeader
            ContentType = "application/json"
        }
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100           
    }

    GetUserStatistics(){
   
        $objectId = $this.Id
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Mail/MailStatistics/$objectId"
            Headers =GetHeader
            ContentType = "application/json"
        }
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100           
    }

    GetBatchList(){
       
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Mail/Batch"
            Headers = GetHeader 
            ContentType = "application/json"
        }

        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
        
    }


   
}