<#################################################################################

DESCRIPTION:
    powershell script calling samples for Product APIs
    
# All rights reserved. 
# Sample scripts in this guide are not supported under any Cloudiway standard support program or service. 
# The sample scripts are provided AS IS without warranty of any kind. 
# Cloudiway disclaims all implied warranties including, without limitation, any implied warranties of merchantability or of fitness for a particular purpose. 
# The entire risk arising out of the use or performance of the sample scripts and documentation remains with you. 
# In no event shall Cloudiway, its authors, or anyone else involved in the creation, production, or delivery of the scripts be liable for any damages whatsoever 
# (including, without limitation, damages for loss of business profits, business interruption, loss of business information, or other pecuniary loss) arising out of
#  the use of or inability to use the sample scripts or documentation, even if Cloudiway has been advised of the possibility of such damages.

##################################################################################>

try {
    Write-Host "................. STARTING MAIN SCRIPT ................."


 #region Config
    #Include files
    $scriptDirectory = Split-Path -Path $MyInvocation.MyCommand.Definition -Parent
    $classes = Get-ChildItem -re "$scriptDirectory\Classes and Functions\" -in *.ps1 
    foreach ( $item in $classes ) {. $item.FullName}
 
    ####### GET CONFIG SETTINGS #######
    $global:HOSTURL = 'https://api-production.cloudiway.com'
    $userId = 'Test@domain.com'       #Your Login
    $userPass = 'Pass'           #Your Password


    # Login
    $global:BEARERTOKEN = Get-BearerToken $userId $userPass


    #Run this to get the list of projects and their corresponding IDs
    #GetProjects





    #Identify the project you want to work on and insert the projectId here
    $global:PROJID = 713
    
    #Run this to get the list of connectors with their corresponding Pool IDs
    #GetConnectors




    #Identify your Pools IDs
    $global:SPool = 3
    $global:TPool = 4

 #endregion

 #Uncomment any function you want to run
    
#region File
#    ##### CRUD #######
#   param ([string] $FName, [string] $LName,[string] $SEmail,[string] $TEmail, [int] $SPool, [int] $TPool,[int] $TRecipient)
#   CreateFileUser 'FName' 'LName' 'test@domain.com' 'TEmail@domain.com' $global:SPool  $global:TPool 1 # TargetRecipientType 1(OneDrive), 2(SharePoint)
#   GetFileUserList
#   DeleteFileUser 10
#   UpdateFileUser 10 'FName' 'LName' 'SEmail@domain.com' 'TEmail@domain.com'   $global:SPool  $global:TPool 1 # TargetRecipientType 1(OneDrive), 2(SharePoint)

#    ##### File Logs and Stats #######
#   GetFileUserBySourceEmail 'test@domain.com'
#   GetFileUserLogs 11
#   GetFileUserStats 11


#    ##### File Jobs #######
#    StartFileJobs 24 "[10]" # JobType: 24 (Audit), 26 (PreProcessing), 27 (Migration)
#    StopFileJobs "[10]"
 
#    ##### File Batches #######
#    GetListFileBatches
#    StartFileBatchJobs  24 1  #JobType: # 24 (Audit), 26 (PreProcessing), 27 (Migration)
#    StopFileBatchJobs 1

#endregion


#region Groups
#    ##### Groups #######
#    GetGroupList

#    ##### CRUD #######
#                                                                                                                 param ( [int] $SPool, [int] $SRecipient, [string] $SName,[string] $SEmail,[string] $SId,[int] $TPool,[int] $TRecipient,[string] $TName, [string] $TEmail )
#    CreateGroupUser 3 8 'TestGoogleGroup' 'Test@source.com' '/kkjjfhh022' 4 1 'TargetTeamName'  'test@Target.com'
#    GetGroupList
#    UpdateGroupUser 38 3 8 'TestGoogleGroupUpdated' 'TestUpdated@source.com' '/kkjjfhh022' 4 1 'TargetTeamName'  'test@Target.com'
#    BulkDeleteGroups '[41]'

#     ##### Group Logs and Stats #######
#    GetGroupBySourceName 'TestGoogleGroup'
#    GetGroupUserLogs 43
#    GetGroupUserStats 43

#     ##### Group Jobs #######
#    StartGroupJobs 18 "[43]" # JobType: 18 (Audit), 20 (PreProcessing), 21 (Migration)
#    StopGroupJobs "[43]"
 
#     ##### Group Batches #######
#    GetListGroupBatches
#    StartGroupBatchJobs  18 3  # JobType: 18 (Audit), 20 (PreProcessing), 21 (Migration)
#    StopGroupBatchJobs 3

#endregion

#region Sites

#    GetSiteList

#    ##### CRUD #######
#    param ( [int] $SPool, [int] $SRecipient, [string] $SName,[string] $SId,[int] $TPool,[int] $TRecipient,[string] $TName, [string] $TUrl )
#    CreateSiteUser 3 9 'TestGoogleSite' '/kkjjfhh022' 4 2 'TargetTeamName'  '/llll/mmm'
#    GetSiteList
#    UpdateSiteUser 48  3 9 'TestGoogleSiteUpdated' '/kkjjfhh022' 4 2 'TargetTeamNameUpdated'  '/llll/mmm'
#    BulkDeleteSites '[49]'

#     ##### Sites Logs and Stats #######
#    GetSiteBySourceName 'TestGoogleSite'
#    GetSiteUserLogs 48
#    GetSiteUserStats 48

#     ##### Site Jobs #######
#    StartSiteJobs 10 "[48]" # JobType: 10 (Audit), 12 (PreProcessing), 13 (Migration)
#    StopSiteJobs "[48]"
 
#    ##### Site Batches #######
#    GetListSiteBatches
#    StartSiteBatchJobs  10 3  # JobType: 10 (Audit), 12 (PreProcessing), 13 (Migration)
#    StopSiteBatchJobs 3

#endregion


 
#region Mails

#    ##### CRUD #######
#    RecipientType0 Standard, 1 Archive, 2 SharedMailbox, 3 RoomsAndEquipment
#    param ([string] $FName, [string] $LName,[string] $SEmail,[int] $SRecipient,[string] $TEmail, [int] $SPool, [int] $TPool,[int] $TRecipient)
#    CreateMailUser 'FName' 'LName' 'test@domain.com' 0 'TEmail@domain.com' 3  4 0
#    GetMailUserList
#    UpdateMailUser 2 'FNameUpdated' 'LNameUpdated' 'test@domain.com' 0 'TEmail@domain.com' 3  4 0
#    BulkDeleteMails '[2]'

   
#    ##### Mail Logs and Stats #######
#    GetMailUserBySourceEmail 'yoo@source.com'
#    GetMailUserLogs 1
#    GetMailUserStats 1

#    ##### Mail Jobs #######
#    StartMailJobs 30 "[1]" # JobType: 30 (Audit), 32 (PreProcessing), 33 (Migration)
#    StopMailJobs "[1]"
 
#    ##### Mail Batches #######
#    GetListMailBatches
#    StartMailBatchJobs  30 3 # JobType: 30 (Audit), 32 (PreProcessing), 33 (Migration)
#    StopMailBatchJobs 3

#endregion

}
catch
{
    Write-Error -Message "Error: $PSItem" -ErrorAction Stop
}
finally
{
    Write-Host ".................ENDING MAIN SCRIPT ................."
}




